// Attract-Mode Front-End - "Shuffle & Slide (Shuffle v2.0)" - FrizzleFried
// Visit my home arcade blogsite - www.idahogaragecade.com

// Layout options

local col = "white,grey 50%,grey 75%,blue, light blue,green,red,ruby,orange,violet,yellow,yellow orange,"; //Added List of Colors to be used for any text - 01/22/2019
local o=0;
local header = "● "
local subheader = "  ○ "
local headerend = "                                                                                                   "

class UserConfig
{ 
</ label=header + "Preview Image Options" + headerend, help="Select preview image options", options=" ", order=o++ /> divider1="";
	
</ label=subheader + "Type of games list preview" + headerend, help="Toggle the type of games list preview",options="Shuffle,Slide,Smooth Slide", order=o++ /> game_list="Shuffle";
</ label=subheader + "Preview Speed" + headerend, help="Adjust games list preview speed",options="Fastest,Fast,Medium,Slow,Slowest", order=o++ /> glspeed="Medium";

</ label=header + "Features" + headerend, help="Select feature options", options=" ", order=o++ /> divider2="";

</ label=subheader + "Animated, Fade or Static Marquee" + headerend, help="Toggle between animated, fade and static marquee images",options="Animated,Static,Fade", order=o++ /> marq="Fade";
</ label=subheader + "Favorites Star" + headerend, help="Toggle favorites star on and off",options="On,Off", order=o++ /> favorites="On";
</ label=subheader + "Progress Bar" + headerend, help="Toggle progress bar on and off",options="On,Off", order=o++ /> progress="On";

</ label=header + "Color Options" + headerend, help="Select different color options", options=" ", order=o++ /> divider3="";

</ label=subheader + "Manufacturer color" + headerend, help="Color of manufacturer name text", options=col, order=o++ /> manuf_color="white";
</ label=subheader + "Year color" + headerend, help="Color of year of manufacture text", options=col, order=o++ /> year_color="white";
</ label=subheader + "Game # Text color" + headerend, help="Color of game number text", options=col, order=o++ /> gamenum_color="white";
</ label=subheader + "Progress Bar Initial Color" + headerend, help="Color of the initial on the progress bar (if enabled)", options=col, order=o++ /> list_color="white";
}
local my_config = fe.get_config();

// Set up art and text elements

fe.layout.width = 720;
fe.layout.height = 480;
local flx = fe.layout.width;
local fly = fe.layout.height;
local flw = fe.layout.width;
local flh = fe.layout.height;
fe.layout.font = "captain"
fe.do_nut( "scripts/animate.nut");
fe.do_nut( "scripts/conveyor_helper.nut" );
fe.do_nut("scripts/carrier.nut");
fe.do_nut("scripts/colors.nut"); // Color.nut by Giacomo Bianchi 10/30/2018

// Configurable Game List - uses the Conveyor_Helper module by ArcadeBliss (http://forum.attractmode.org/index.php?topic=1945.0)

if ( my_config["game_list"] == "Slide" )
{
local glist = MyGameList();

	glist.type = ch.Linear_Horizontal; 					// OPTIONS: ch.Spinwheel / ch.Linear_Vertical / ch.Linear_Horizontal
	glist.bend.direction = ch.Right;					// OPTIONS: ch.Left / ch.Right
	glist.bend.gl_radius = 0;
	glist.x = -690;										// OPTIONS: top left x-coordinate if gamelist is linear or the center x-coordinate if a spinwheel
	glist.y = 50;										// OPTIONS: top left y-coordinate if gamelist is linear or the center y-coordinate if a spinwheel
	glist.width = 2160; 								// OPTIONS: linear game list total width in pixels
	glist.height = 260; 								// OPTIONS: linear list's height in pixels
if ( my_config["glspeed"] == "Fastest" )
{
	glist.ms_speed = 50;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Fast" )
{
	glist.ms_speed = 100;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Medium" )
{
	glist.ms_speed = 150;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Slow" )
{
	glist.ms_speed = 225;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Slowest" )
{
	glist.ms_speed = 300;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}		
	
	glist.fade_after_nav = 255;							// OPTIONS: 0-255 Fades the entire gamelist's alpha channel after navigation to this value. set to 255 to disable fading
	glist.fade_delay = 5000; 							// the amount of time in milliseconds before the fade should start
	glist.fade_speed = 5.0; 							// the mulitplier controlling the speed of the fade
	glist.fade_selected = false;					 	// OPTIONS: TRUE/FALSE fade selected game if gamelist fading is active
		
	glist.linear.padding = 025;							// the amount of padding in pixels between each gamelist item
	
	glist.item.contentTemplate = ch.Artwork;			// OPTIONS: ch.Artwork / ch.Text / ch.Artwork_and_Text / ch.Artwork_or_Text / ch.Flyer_and_Artwork 
	glist.item.count = 5; 								// OPTIONS: Total number of gamelist items to display
       
	glist.item.sizeScaling.low = 1.0; 					// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.sizeScaling.high = 1.0; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.sizeScaling.currentlySelected = 1.00;	// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.alphaScaling.low = 125; 					// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.alphaScaling.high = 125; 				// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.alphaScaling.currentlySelected = 255;	// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.height = 280; 							// OPTIONS: Height of each gameList item in pixels before scaling - dynamic with linear vertical lists
	glist.item.width = 400;								// OPTIONS: Width of each gameList item in pixels before scaling - dynamic with linear horizontal lists
                  
	glist.artwork.type = "snap"; 						// OPTIONS: name of the artwork to use for the conveyour
	glist.artwork.preserveAspect = true;				// OPTIONS: true / false
		
	glist.show();
}

if ( my_config["game_list"] == "Shuffle" )
{
local glist = MyGameList();

	glist.type = ch.Coverflow; 							// OPTIONS: ch.Spinwheel / ch.Linear_Vertical / ch.Linear_Horizontal
	glist.bend.direction = ch.Right;					// OPTIONS: ch.Left / ch.Right
	glist.bend.gl_radius = 0;
	glist.x = 360;										// OPTIONS: top left x-coordinate if gamelist is linear or the center x-coordinate if a spinwheel
	glist.y = 190;										// OPTIONS: top left y-coordinate if gamelist is linear or the center y-coordinate if a spinwheel
	glist.width = 720; 									// OPTIONS: linear game list total width in pixels
	glist.height = 250; 								// OPTIONS: linear list's height in pixels
if ( my_config["glspeed"] == "Fastest" )
{
	glist.ms_speed = 20;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Fast" )
{
	glist.ms_speed = 90;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Medium" )
{
	glist.ms_speed = 150;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Slow" )
{
	glist.ms_speed = 225;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}
if ( my_config["glspeed"] == "Slowest" )
{
	glist.ms_speed = 300;								// OPTIONS: in milliseconds, sets the speed of the conveyor
}		
	
	glist.fade_after_nav = 255;							// OPTIONS: 0-255 Fades the entire gamelist's alpha channel after navigation to this value. set to 255 to disable fading
	glist.fade_delay = 5000; 							// the amount of time in milliseconds before the fade should start
	glist.fade_speed = 5.0; 							// the mulitplier controlling the speed of the fade
	glist.fade_selected = false;					 	// OPTIONS: TRUE/FALSE fade selected game if gamelist fading is active
		
	glist.linear.padding = 15;							// the amount of padding in pixels between each gamelist item
	
	glist.item.contentTemplate = ch.Artwork;			// OPTIONS: ch.Artwork / ch.Text / ch.Artwork_and_Text / ch.Artwork_or_Text / ch.Flyer_and_Artwork 
	glist.item.count = 5; 								// OPTIONS: Total number of gamelist items to display
       
	glist.item.sizeScaling.low = 1.0; 					// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.sizeScaling.high = 1.0; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.sizeScaling.currentlySelected = 1.00;	// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.alphaScaling.low = 150; 					// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.alphaScaling.high = 150; 				// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.alphaScaling.currentlySelected = 255;	// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.height = 285; 							// OPTIONS: Height of each gameList item in pixels before scaling - dynamic with linear vertical lists
	glist.item.width = 355;								// OPTIONS: Width of each gameList item in pixels before scaling - dynamic with linear horizontal lists
       	
	glist.artwork.type = "snap"; 						// OPTIONS: name of the artwork to use for the conveyour
	glist.artwork.preserveAspect = true;				// OPTIONS: true / false
		
	glist.show();
}

if (my_config["game_list"] == "Smooth Slide" )
{
	if (my_config["glspeed"] == "Fastest" )
	{
		local carrier = Carrier( flx*-0.517, fly*0.062, flw*2.031, flh*0.665, 3, 3, 30, 0, 0 )
		carrier.surfacePosSmoothing = 0.60
	}
	if (my_config["glspeed"] == "Fast" )
	{
		local carrier = Carrier( flx*-0.517, fly*0.062, flw*2.031, flh*0.665, 3, 3, 30, 0, 0 )
		carrier.surfacePosSmoothing = 0.83
	}
	if (my_config["glspeed"] == "Medium" )
	{
		local carrier = Carrier( flx*-0.517, fly*0.062, flw*2.031, flh*0.665, 3, 3, 30, 0, 0 )
		carrier.surfacePosSmoothing = 0.90
	}
		if (my_config["glspeed"] == "Slow" )
	{
		local carrier = Carrier( flx*-0.517, fly*0.062, flw*2.031, flh*0.665, 3, 3, 30, 0, 0 )
		carrier.surfacePosSmoothing = 0.94
	}
		if (my_config["glspeed"] == "Slowest" )
	{
		local carrier = Carrier( flx*-0.517, fly*0.062, flw*2.031, flh*0.665, 3, 3, 30, 0, 0 )
		carrier.surfacePosSmoothing = 0.97
	}

	// videotheme timer Code by qqplayer

::OBJECTS1 <- {
artwork_videotheme = fe.add_artwork("snap", flx*0.201, fly*0.125, flw*0.596, flh*0.540),
}

OBJECTS1.artwork_videotheme.visible=false;

::videoSound <- Vid.NoAudio;
OBJECTS1.artwork_videotheme.video_flags = videoSound;

local settings = {
   delay_timer = 0,
   play_delay = 2000,
   stop_play = 235000,
}

function on_transition_videotheme( ttype, var, ttime ) {
 switch ( ttype ) {
  case Transition.StartLayout:
  case Transition.ToNewSelection:
  case Transition.ToNewList:
  case Transition.EndNavigation:
        OBJECTS1.artwork_videotheme.video_flags = Vid.NoAutoStart;
        settings.delay_timer = fe.layout.time;
        OBJECTS1.artwork_videotheme.visible=false;
       break;
  }
 return false;
}

fe.add_transition_callback( "on_transition_videotheme" );

function on_tick_videotheme(tick_time) {
   if ( !OBJECTS1.artwork_videotheme.video_playing && tick_time - settings.delay_timer >= settings.play_delay ) {
   
        OBJECTS1.artwork_videotheme.video_playing = true;
        
        ::videoSound <- Vid.Default;
        OBJECTS1.artwork_videotheme.video_flags = videoSound;        
        
        OBJECTS1.artwork_videotheme.visible=true;
        
        OBJECTS1.artwork_videotheme.alpha = 0
        local alpha_artwork_videotheme_0 = {
        property = "alpha", start = 0 end = 255, time = 500 easing = Easing.Out,
        }
 
        animation.add( PropertyAnimation( OBJECTS1.artwork_videotheme, alpha_artwork_videotheme_0 ) );       
    }
    
    else if ( tick_time - settings.delay_timer >= settings.stop_play ) {
        
        OBJECTS1.artwork_videotheme.visible=false;      
    }
}
fe.add_ticks_callback(this, "on_tick_videotheme");
}

// Marquee	

if ( my_config["marq"] == "Fade" )
{	
local mmarquee = fe.add_artwork( "marquee", 160, 335, 402, 130 );
local mmarquee_fade_cfg = {
	when =Transition.ToNewSelection,
	property = "alpha",
	start = 0,
	end = 255,
	time = 750,
}	
animation.add( PropertyAnimation( mmarquee, mmarquee_fade_cfg ) );
}
	
if ( my_config["marq"] == "Animated" )
{
local mmarquee = fe.add_artwork( "marquee", 160, 335, 402, 130 );
local mmarquee_scale_cfg = {
	when =Transition.ToNewSelection,
	property = "scale",
	start = 0.5,
	end = 1.0,
	time = 1000,
	tween = Tween.Bounce,
}
animation.add( PropertyAnimation( mmarquee, mmarquee_scale_cfg ) );
}	

if ( my_config["marq"] == "Static" )
{
fe.add_artwork( "marquee", 160, 335, 402, 130 );
}
	
// Background

fe.add_image( "images/glbg.png", 0, 0, 720, 480 );

// Text Bits

local gamenum = fe.add_text("[ListEntry] / [ListSize] ",90,8,136,30);
	gamenum.set_rgb( 0, 0, 0 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",92,10,136,30);
	gamenum.set_rgb( 255, 255, 255 );
	colors( gamenum, my_config["gamenum_color"], 0 );

local year = fe.add_text("[Year]",540,8,80,30);
	year.set_rgb( 0, 0, 0 );
local year = fe.add_text("[Year]",542,10,80,30);
	colors( year, my_config["year_color"], 0 );

local manuf = fe.add_text("[Manufacturer]",200,8,320,30);
	manuf.set_rgb( 0, 0, 0 );
local manuf = fe.add_text("[Manufacturer]",202,10,320,30);
	colors( manuf, my_config["manuf_color"], 0 );

// Favorites

if ( my_config["favorites"] == "On" )
{
function FavStar() {
	if (fe.game_info( Info.Favourite ) == "1") return "images/star.png";
	}
	local Fav = fe.add_image("[!FavStar]", flx*0.035, fly*0.010, flw*0.070, flh*0.100);
	local Fav_move_cfg = {
		when =Transition.ToNewSelection,
		property = "scale",
		start = 3.5,
		end = 1.0,
		time = 1500,
		tween = Tween.Bounce,
	}	
animation.add( PropertyAnimation( Fav, Fav_move_cfg ) );
}
			
// Add Number of Players 

local bg_image = fe.add_image("images/unknown.png", flx*0.833, fly* 0.700, flw*0.126, flh*0.135);
bg_image.set_rgb (0,0,0);
bg_image.alpha = 100

local pb_x = flx*0.827;
local pb_y = fly*0.694;
local pb_w = flw*0.126;
local pb_h = flh*0.135;
local pb_text_x = pb_x-(flx*0.006);
local pb_text_y = pb_y+(fly*0.018);
local pb_text_w = pb_w;
local pb_text_h = pb_h-(flh*0.045);

function PlayerIcon() {
if (fe.game_info( Info.Players ) >= "1") return "images/players.png";
else if (fe.game_info( Info.Players ) <= "" || " ") return "images/unknownp.png";
}

local PlayerIcon= fe.add_image("[!PlayerIcon]", pb_x, pb_y, pb_w, pb_h);
local p = fe.add_text( "[Players]", pb_text_x, pb_text_y, pb_text_w, pb_text_h);
	p.charsize = 48;
	p.set_rgb( 0, 0, 0 );
	p.font="Roboto";
	p.align = Align.Centre;
	p.style = Style.Bold;
	
// Add Genre images

local bg_image = fe.add_image("images/unknown.png", flx*0.833, fly* 0.851, flw*0.126, flh*0.135);
bg_image.set_rgb (0,0,0);
bg_image.alpha = 100
	
local genre_image = fe.add_image("images/unknown.png", flx*0.827, fly* 0.845, flw*0.126, flh*0.135);
genre_image.trigger = Transition.EndNavigation;	

class GenreImage
{
	mode = 1;       //0 = first match, 1 = last match, 2 = random
	supported = {
        //filename : [ match1, match2 ]
        "act": [ "action","platformer", "platform" ],
		"plt": [ "platformer", "platform" ],
        "avg": [ "adventure" ],
        "ftg": [ "fighting", "fighter", "beat'em up" ],
        "pzg": [ "puzzle" ],
		"mze": [ "maze" ],
		"rhy": [ "rhythm" ],
		"pbl": [ "pinball" ],
        "rcg": [ "racing", "driving" ],
        "rpg": [ "rpg", "role playing", "role-playing", "role playing game" ],
        "stg": [ "shooter", "shmup" ],
        "fly": [ "fly", "flying" ],
        "spt": [ "sports", "boxing", "golf", "baseball", "football", "soccer" "Sports" ],
        "bxg": [ "boxing" ],
        "slg": [ "strategy"]
    }
ref = null;
constructor( image )
{
	ref = image;
	fe.add_transition_callback( this, "transition" );
}
    
function transition( ttype, var, ttime )
{
	if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
	{
			local cat = " " + fe.game_info(Info.Category, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
}
GenreImage(genre_image);

// Add Control images

local bg_image = fe.add_image("images/unknown.png", flx*0.056, fly* 0.700, flw*0.126, flh*0.135);
bg_image.set_rgb (0,0,0);
bg_image.alpha = 100
	
local control_image = fe.add_image("images/unknown.png", flx*0.050, fly* 0.694, flw*0.126, flh*0.135);
control_image.trigger = Transition.EndNavigation;	

class ControlImage
{
	mode = 1;       //0 = first match, 1 = last match, 2 = random
	supported = {
        //filename : [ match1, match2 ]
        "8way": [ "joystick (8-way)" ],
		"4way": [ "joystick (4-way)" ],
		"2way": [ "joystick (2-way)" ],
        "analog": [ "analog", "positional" ],
        "spin": [ "dial", "paddle" ],
        "track": [ "trackball" ],
		"gun": [ "lightgun" ],
		"2sticks": [ "double joystick (8-way)", "double joystick (4-way)", "double joystick (2-way)", "vertical double joystick (8-way)", "vertical double joystick (4-way)", "vertical double joystick (2-way)"  ],
		"butonly": [ "only_buttons" ]
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Control, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
}
ControlImage(control_image);

// Add Buttons images

local bg_image = fe.add_image("images/unknown.png", flx*0.056, fly* 0.851, flw*0.126, flh*0.135);
bg_image.set_rgb (0,0,0);
bg_image.alpha = 100
local buttons_image = fe.add_image("images/unknown.png", flx*0.050, fly* 0.845, flw*0.126, flh*0.135);
buttons_image.trigger = Transition.EndNavigation;	

class ButtonsImage
{
    mode = 1;       //0 = first match, 1 = last match, 2 = random
    supported = {
        //filename : [ match1, match2 ]
        "0buttons": [ "0" ],
		"1button":  [ "1" ],
		"2buttons": [ "2" ],
        "3buttons": [ "3" ],
        "4buttons": [ "4" ],
        "5buttons": [ "5" ],
		"6buttons": [ "6" ],
    }
    ref = null;
    constructor( image )
    {
        ref = image;
        fe.add_transition_callback( this, "transition" );
    }
    
    function transition( ttype, var, ttime )
    {
        if ( ttype == Transition.ToNewSelection || ttype == Transition.ToNewList )
        {
            local cat = " " + fe.game_info(Info.Buttons, var).tolower();
            local matches = [];
            foreach( key, val in supported )
            {
                foreach( nickname in val )
                {
                    if ( cat.find(nickname, 0) ) matches.push(key);
                }
            }
            if ( matches.len() > 0 )
            {
                switch( mode )
                {
                    case 0:
                        ref.file_name = "images/" + matches[0] + ".png";
                        break;
                    case 1:
                        ref.file_name = "images/" + matches[matches.len() - 1] + ".png";
                        break;
                    case 2:
                        local random_num = floor(((rand() % 1000 ) / 1000.0) * ((matches.len() - 1) - (0 - 1)) + 0);
                        ref.file_name = "images/" + matches[random_num] + ".png";
                        break;
                }
            } else
            {
                ref.file_name = "images/unknown.png";
            }
        }
    }
}
ButtonsImage(buttons_image);

// Progress Bar

if ( my_config["progress"] == "On" )
{
fe.add_image( "images/bar_h.png", flx*0.30, fly*0.595, flw*0.40, flh*0.070 );
	local 	list_inc = fly*0.393 / (fe.list.size-1);
	local 	current_pos = flx*0.100 + (fe.list.index * list_inc);
	local 	list_pos_image = fe.add_image( "images/circle.png", current_pos, fly*0.603, flw*0.032, flh*0.055 );
	local 	list_label = fe.add_text( "[Title]",current_pos, fly*0.595, flw*0.0375, flh*0.060);
			list_label.font="captain"
			colors( list_label, my_config["list_color"], 0 );
			
function progress_bar( ttype, var, ttime )	
	{
		current_pos = flx*0.358 + (fe.list.index*list_inc);
		list_pos_image.x = current_pos+2;
		list_label.x = current_pos;	
		return false;
	}
fe.add_transition_callback( "progress_bar" );
}
	
// Game Select Sound

function select_sound( ttype, var, ttime ) {
 switch ( ttype ) {

  case Transition.ToNewSelection:
	      local sound = fe.add_sound("glclick.mp3");
	      sound.playing=true;
  break;
  }
 return false;
}
fe.add_transition_callback( "select_sound" );